_TITLE "Part 1 TrackWord algo"
'started 2018-08-06 by bplus"
'QB64 X 64 version 1.2 20180228/86  from git b301f92

'this file builds the Master Snake.txt file
' what is that?
'
' for squares numbered
' 1 2 3
' 4 5 6
' 7 8 9
'
' the Master Snake file contains all possible connections you can make between squares.

' With that file you can translate the letters to square numbers as a sort of encryption or decryption
' if M is in the 1 square translate all snakes with number 1 to M in 1 position
' if B is in the 2 square translate all snakes with number 2 to B in 2 position
' ... we leave that to the application file.


' !!!!!!!!!!!!!!!!!!!   we make the Master Snakes.txt once and for all time   !!!!!!!!!!!!!!!!

CONST ww = 800
CONST wh = 600
SCREEN _NEWIMAGE(ww, wh, 32)
_SCREENMOVE (1280 - ww) / 2 + 30, (760 - wh) / 2


nCells = 9
DIM SHARED connects$(nCells)
connects$(1) = "245"
connects$(2) = "13456"
connects$(3) = "256"
connects$(4) = "12578"
connects$(5) = "12346789"
connects$(6) = "23589"
connects$(7) = "458"
connects$(8) = "45679"
connects$(9) = "568"

''test code  ==================================
'DIM SHARED bigBuild$
'b1$ = ""
't1$ = ""
'build "1", b1$, t1$
'REDIM oneArr$(0)
'Split oneArr$(), bigBuild$, ", "
'PRINT UBOUND(oneArr$)
'INPUT "OK enter for display..", temp$
'display oneArr$()
'PRINT "Repeats"
'FOR i = 0 TO UBOUND(oneArr$)
'    FOR j = i + 1 TO UBOUND(oneArr$)
'        IF oneArr$(i) = oneArr$(j) THEN PRINT oneArr$(i); ", ";
'    NEXT
'NEXT
'PRINT: PRINT
'PRINT "End of repeat check."
''results
''  for squares 1, 3, 7, 9  1369 snakes each  x4 = 5476
''  for squares 2, 4, 6, 8  1031 snakes each  X4 = 4124
''  for square           5   656 snake           =  656
''  total snakes ================================= 10256 just as Qwerkey had reported!
'END
''end test code  =================================

DIM SHARED snakes$(10256)
DIM SHARED index
index = 1
FOR i = 1 TO 9
    digit$ = MID$("123456789", i, 1)
    b1$ = "": t1$ = ""
    build2 digit$, b1$, t1$
NEXT
OPEN "Master Snakes.txt" FOR OUTPUT AS #1
FOR i = 1 TO 10256
    PRINT #1, snakes$(i)
NEXT
CLOSE #1
PRINT "Done with part 1, build the,  Master Snake.txt, file."


SUB build2 (cn$, b$, t$)
    'dim shared bigBuild$
    bb$ = b$ + cn$
    tt$ = t$ + cn$
    IF LEN(bb$) >= 3 THEN snakes$(index) = bb$: index = index + 1
    list$ = connects$(VAL(cn$))
    FOR i = 1 TO LEN(list$)
        c$ = MID$(list$, i, 1)
        IF INSTR(t$, c$) <= 0 THEN
            build2 c$, bb$, tt$
        END IF
    NEXT
END SUB

SUB build (cn$, b$, t$)
    'dim shared bigBuild$
    bb$ = b$ + cn$
    tt$ = t$ + cn$
    IF LEN(bb$) >= 3 THEN bigBuild$ = bigBuild$ + bb$ + ", "
    list$ = connects$(VAL(cn$))
    FOR i = 1 TO LEN(list$)
        c$ = MID$(list$, i, 1)
        IF INSTR(t$, c$) <= 0 THEN
            build c$, bb$, tt$
        END IF
    NEXT
END SUB

'didn't really need this
SUB Split (arr() AS STRING, mystr AS STRING, delim AS STRING)
    DIM s AS STRING
    curpos = 1 'is default single type better than long type integer? (better as in greater range)
    arrpos = 0
    le = LEN(mystr)
    dpos = INSTR(curpos, mystr, delim)
    DO UNTIL dpos = 0
        arr(arrpos) = MID$(mystr, curpos, dpos - curpos)
        arrpos = arrpos + 1
        REDIM _PRESERVE arr(arrpos + 1) AS STRING 'AS STRING required or it assumes the default type which is SINGLE
        curpos = dpos + LEN(delim)
        dpos = INSTR(curpos, mystr, delim)
    LOOP
    arr(arrpos) = MID$(mystr, curpos)
    REDIM _PRESERVE arr(arrpos) AS STRING
END SUB

SUB display (arr() AS STRING)
    lb = LBOUND(arr): ub = UBOUND(arr)
    IF ub - lb + 1 < 21 THEN top = ub ELSE top = lb + 19
    CLS: PRINT "press any key to quit scroller..."
    LOCATE 2, 1
    FOR i = lb TO top
        PRINT arr(i)
    NEXT
    DO
        IF ub - lb + 1 > 20 THEN
            DO WHILE _MOUSEINPUT
                IF row >= lb THEN row = row + _MOUSEWHEEL ELSE row = lb 'prevent under scrolling
                IF row > ub - 19 THEN row = ub - 19 'prevent over scrolling
                IF prevrow <> row THEN 'look for a change in row value
                    IF row >= lb AND row <= ub - 19 THEN
                        CLS: PRINT "press any key to quit scroller..."
                        LOCATE 2, 1
                        FOR n = row TO row + 19
                            PRINT arr(n)
                        NEXT
                    END IF
                END IF
                prevrow = row 'store previous row value
            LOOP
        END IF
    LOOP UNTIL INKEY$ > ""
END SUB

